%define module_name Struct-Diff
# BEGIN SourceDeps(oneline):
BuildRequires: perl(Algorithm/Diff.pm) perl(Carp.pm) perl(Clone.pm) perl(Data/Dumper.pm) perl(Exporter.pm) perl(ExtUtils/MakeMaker.pm) perl(JSON.pm) perl(Scalar/Util.pm) perl(Storable.pm) perl(Test/More.pm) perl(parent.pm) perl(strict.pm) perl(warnings.pm)
# END SourceDeps(oneline)
%define _unpackaged_files_terminate_build 1
BuildRequires: rpm-build-perl perl-devel perl-podlators

Name: perl-%module_name
Version: 0.98
Release: alt1
Summary: Recursive diff tools for nested perl structures
Group: Development/Perl
License: perl
Url: %CPAN %module_name

Source0: http://mirror.yandex.ru/mirrors/cpan/authors/id/M/MI/MIXAS/%{module_name}-%{version}.tar.gz
BuildArch: noarch

%description
use Struct::Diff qw(diff dselect dsplit patch);

    $a = {x => [7,{y => 4}]};
    $b = {x => [7,{y => 9}],z => 33};

    $diff = diff($a, $b, noO => 1, noU => 1);       # omit unchanged and old values for changed items
    # $diff == {D => {x => {D => [{I => 1,N => {y => 9}}]},z => {A => 33}}};

    @items = dselect($diff, fromD => ['z']);        # get status for a particular key
    # @items == ({z => {A => 33}});

    $href = dsplit($diff);                          # divide diff
    # $dsplit->{a} not exists                       # because unchanged omitted and all other items originated from $b
    # $dsplit->{b} == {x => [{y => 9}],z => 33};

    patch($a, $diff);
    # $a now equal to $b
%prep
%setup -q -n %{module_name}-%{version}

%build
%perl_vendor_build

%install
%perl_vendor_install

%files
%doc Changes README
%perl_vendor_privlib/S*

%changelog
* Sat Jan 12 2019 Igor Vlasenko <viy@altlinux.ru> 0.98-alt1
- regenerated from template by package builder

* Tue Oct 30 2018 Igor Vlasenko <viy@altlinux.ru> 0.97-alt1
- regenerated from template by package builder

* Mon Apr 09 2018 Igor Vlasenko <viy@altlinux.ru> 0.96-alt1
- regenerated from template by package builder

* Sun Mar 11 2018 Igor Vlasenko <viy@altlinux.ru> 0.95-alt1
- regenerated from template by package builder

* Tue Dec 26 2017 Igor Vlasenko <viy@altlinux.ru> 0.94-alt1
- regenerated from template by package builder

* Wed Dec 20 2017 Igor Vlasenko <viy@altlinux.ru> 0.93-alt1
- regenerated from template by package builder

* Sun Nov 05 2017 Igor Vlasenko <viy@altlinux.ru> 0.91-alt1
- regenerated from template by package builder

* Thu Oct 26 2017 Igor Vlasenko <viy@altlinux.ru> 0.90-alt1
- regenerated from template by package builder

* Wed Aug 02 2017 Igor Vlasenko <viy@altlinux.ru> 0.89-alt1
- regenerated from template by package builder

* Tue Feb 14 2017 Igor Vlasenko <viy@altlinux.ru> 0.86-alt1
- regenerated from template by package builder

* Thu Dec 29 2016 Igor Vlasenko <viy@altlinux.ru> 0.85-alt1
- regenerated from template by package builder

* Sat Dec 17 2016 Igor Vlasenko <viy@altlinux.ru> 0.83-alt1
- regenerated from template by package builder

* Tue Nov 01 2016 Igor Vlasenko <viy@altlinux.ru> 0.82-alt1
- regenerated from template by package builder

* Sun Sep 18 2016 Igor Vlasenko <viy@altlinux.ru> 0.70-alt1
- regenerated from template by package builder

* Thu Sep 01 2016 Igor Vlasenko <viy@altlinux.ru> 0.65-alt1
- regenerated from template by package builder

* Mon Jul 25 2016 Igor Vlasenko <viy@altlinux.ru> 0.62-alt1
- regenerated from template by package builder

* Sun Jun 05 2016 Igor Vlasenko <viy@altlinux.ru> 0.55-alt1
- initial import by package builder

